package demo;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.nio.BufferOverflowException;

import javax.swing.JButton;
import javax.swing.JFrame;

import com.elixirtech.data2.datasource.DataSourceDefinition;
import com.elixirtech.report2.physical.viewer.GlintCanvas;
import com.elixirtech.report2.physical.viewer.IViewerCanvas;
import com.elixirtech.report2.raw.model.Parameter;
import com.elixirtech.report2.raw.model.RawReport;
import com.elixirtech.report2.runtime.BasicReportHost;
import com.elixirtech.report2.runtime.IFileObject;
import com.elixirtech.report2.runtime.IReportAdmin;
import com.elixirtech.report2.runtime.IReportEngine;
import com.elixirtech.report2.runtime.ReportEngineFactory;


public class ReportViewer extends JFrame{
	
	
	public ReportViewer()
	{
		try
		{
			//Work around for 5.0.x. Fixed in 5.1 missing mapping.
			DataSourceDefinition.registerDefinition("Java", Class.forName("com.elixirtech.data2.datasource.object.ObjectDefinition"));
		}
		catch (ClassNotFoundException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		getContentPane().add(BorderLayout.CENTER,m_View);
		m_View.addActionListener(new ActionListener()
				{

					public void actionPerformed(ActionEvent arg0) {
						showReport();
					}
				
				});
		ReportEngineFactory.init(new BasicReportHost(this));
		pack();
	}
	
	public void showReport()
	{
		IReportEngine re = ReportEngineFactory.newEngineInstance();
		IReportAdmin ra = ReportEngineFactory.newAdminInstance();
		ra.addLocalFileSystem("Clinic", "C:\\Program Files\\Elixir Report Professional 5\\runtime\\samples\\Java_Object_DS\\reports");
		ByteArrayOutputStream bos = null;
		 try {
		
			// clinic name is filesystem name and 
			RawReport rr = re.getRawReport("/Clinic/Patient_List_By_BirthYear.rml");
			java.util.Properties prop = new java.util.Properties();
			prop.put("begain","1950");
			prop.put("end","1980");
			bos =  new ByteArrayOutputStream();
			BufferedOutputStream buffered = new BufferedOutputStream(bos);
			re.renderReport(rr, "application/x-glint",buffered, prop);
			bos.flush();
            byte[] report = bos.toByteArray();
            GlintView gv = new GlintView();
            gv.setData(report);
            gv.show();
            
			
		} catch (Exception e) {
			e.printStackTrace();
		}finally
		{
			if (bos!=null)
				try {
					bos.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}

	}
	
	public static void main(String[] args) {
		ReportViewer vr = new ReportViewer();
		vr.setVisible(true);
	}
	
	public JButton m_View = new JButton("View");

}
